Index: /palm/trunk/UTIL/inifor/src/grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/grid.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/grid.f90	(revision 3395)
@@ -26,4 +26,14 @@
 ! -----------------
 ! $Id$
+! Added computation of geostrophic winds form COSMO pressure fields
+! Introduced averaging grids and internal 'output' variables for computation of
+!     geostrophic and large-scale forcings
+! Merged qv, uv and vg output variables and 'temperature' IO group into new
+!     'thermodynamics' IP group
+! Cleaned up terminal output, show some messages only with --debug option
+! Improved variable naming and readability
+! 
+! 
+! 3183 2018-07-27 14:25:55Z suehring
 ! Introduced new PALM grid stretching
 ! Updated variable names and metadata for PIDS v1.9 compatibility
@@ -61,5 +71,6 @@
         ONLY:  DATE, EARTH_RADIUS, TO_RADIANS, TO_DEGREES, PI, dp, hp, sp,     &
                SNAME, LNAME, PATH, FORCING_STEP, WATER_ID, FILL_ITERATIONS,    &
-               BETA, P_SL, T_SL, BETA, RD, G, P_REF, RD_PALM, CP_PALM, RHO_L
+               BETA, P_SL, T_SL, BETA, RD, RV, G, P_REF, RD_PALM, CP_PALM,     &
+               RHO_L, OMEGA, HECTO
     USE io,                                                                    &
         ONLY:  get_netcdf_variable, get_netcdf_attribute,                      &
@@ -68,9 +79,11 @@
         ONLY:  NF90_MAX_NAME, NF90_MAX_VAR_DIMS
     USE transform,                                                             &
-        ONLY:  rotate_to_cosmo, find_horizontal_neighbours,                    &
+        ONLY:  average_2d, rotate_to_cosmo, find_horizontal_neighbours,&
                compute_horizontal_interp_weights,                              &
-               find_vertical_neighbours_and_weights, interpolate_2d,           &
-               gamma_from_hemisphere, phic_to_phin, lamc_to_lamn, average_2d,  &
-               project, centre_velocities, phi2phirot, rla2rlarot, uv2uvrot
+               find_vertical_neighbours_and_weights_interp,                    &
+               find_vertical_neighbours_and_weights_average, interpolate_2d,   &
+               gamma_from_hemisphere, phic_to_phin, lamc_to_lamn,              &
+               project, centre_velocities, phi2phirot, rla2rlarot, uv2uvrot,   &
+               phirot2phi, rlarot2rla
     USE types
     USE util
@@ -80,4 +93,7 @@
     SAVE
     
+    REAL(dp) ::  averaging_angle   = 0.0_dp       !< latitudal and longitudal width of averaging regions [rad]
+    REAL(dp) ::  averaging_width_ns = 0.0_dp       !< longitudal width of averaging regions [m]
+    REAL(dp) ::  averaging_width_ew = 0.0_dp       !< latitudal width of averaging regions [m]
     REAL(dp) ::  phi_equat         = 0.0_dp       !< latitude of rotated equator of COSMO-DE grid [rad]
     REAL(dp) ::  phi_n             = 0.0_dp       !< latitude of rotated pole of COSMO-DE grid [rad]
@@ -87,4 +103,10 @@
     REAL(dp) ::  phi_cn            = 0.0_dp       !< latitude of the rotated pole relative to the COSMO-DE grid [rad]
     REAL(dp) ::  lambda_cn         = 0.0_dp       !< longitude of the rotated pole relative to the COSMO-DE grid [rad]
+    REAL(dp) ::  lam_centre        = 0.0_dp       !< longitude of the PLAM domain centre in the source (COSMO rotated-pole) system [rad]
+    REAL(dp) ::  phi_centre        = 0.0_dp       !< latitude of the PLAM domain centre in the source (COSMO rotated-pole) system [rad]
+    REAL(dp) ::  lam_east          = 0.0_dp       !< longitude of the east central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
+    REAL(dp) ::  lam_west          = 0.0_dp       !< longitude of the west central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
+    REAL(dp) ::  phi_north         = 0.0_dp       !< latitude of the north central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
+    REAL(dp) ::  phi_south         = 0.0_dp       !< latitude of the south central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
     REAL(dp) ::  gam               = 0.0_dp       !< angle for working around phirot2phi/rlarot2rla bug
     REAL(dp) ::  dx                = 0.0_dp       !< PALM-4U grid spacing in x direction [m]
@@ -100,8 +122,7 @@
     REAL(dp) ::  dyi               = 0.0_dp       !< inverse PALM-4U grid spacing in y direction [m^-1]
     REAL(dp) ::  dzi               = 0.0_dp       !< inverse PALM-4U grid spacing in z direction [m^-1]
+    REAL(dp) ::  f3                = 0.0_dp       !< Coriolis parameter
     REAL(dp) ::  lx                = 0.0_dp       !< PALM-4U domain size in x direction [m]
     REAL(dp) ::  ly                = 0.0_dp       !< PALM-4U domain size in y direction [m]
-    REAL(dp) ::  ug                = 0.0_dp       !< geostrophic wind in x direction [m/s]
-    REAL(dp) ::  vg                = 0.0_dp       !< geostrophic wind in y direction [m/s]
     REAL(dp) ::  p0                = 0.0_dp       !< PALM-4U surface pressure, at z0 [Pa]
     REAL(dp) ::  x0                = 0.0_dp       !< x coordinate of PALM-4U Earth tangent [m] 
@@ -140,7 +161,4 @@
     INTEGER ::  dz_stretch_level_end_index(9)               !< vertical grid level index until which the vertical grid spacing is stretched
     INTEGER ::  dz_stretch_level_start_index(9)             !< vertical grid level index above which the vertical grid spacing is stretched
-    INTEGER ::  i     !< indexing variable
-    INTEGER ::  average_imin, average_imax, average_jmin, average_jmax !< index ranges for profile averaging
-    INTEGER ::  k     !< indexing variable
     INTEGER ::  nt    !< number of output time steps
     INTEGER ::  nx    !< number of PALM-4U grid points in x direction
@@ -164,6 +182,4 @@
     LOGICAL ::  profile_grids_required
 
-    INTEGER ::  n_invar = 0 !< number of variables in the input variable table
-    INTEGER ::  n_outvar = 0 !< number of variables in the output variable table
     TYPE(nc_var), ALLOCATABLE, TARGET ::  input_var_table(:)  !< table of input variables
     TYPE(nc_var), ALLOCATABLE, TARGET ::  output_var_table(:) !< table of input variables
@@ -219,8 +235,11 @@
     TYPE(grid_definition), TARGET ::  w_south_intermediate            !< 
     TYPE(grid_definition), TARGET ::  w_top_intermediate              !< 
-    TYPE(grid_definition), TARGET ::  scalar_profile_grid             !< 
-    TYPE(grid_definition), TARGET ::  scalar_profile_intermediate     !< 
-    TYPE(grid_definition), TARGET ::  w_profile_grid                  !< 
-    TYPE(grid_definition), TARGET ::  w_profile_intermediate          !< 
+
+    TYPE(grid_definition), TARGET ::  north_averaged_scalar_profile
+    TYPE(grid_definition), TARGET ::  south_averaged_scalar_profile
+    TYPE(grid_definition), TARGET ::  west_averaged_scalar_profile
+    TYPE(grid_definition), TARGET ::  east_averaged_scalar_profile
+    TYPE(grid_definition), TARGET ::  averaged_scalar_profile
+    TYPE(grid_definition), TARGET ::  averaged_w_profile
 
     TYPE(io_group), ALLOCATABLE, TARGET ::  io_group_list(:)  !< List of I/O groups, which group together output variables that share the same input variable
@@ -237,4 +256,8 @@
     CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  radiation_files
     CHARACTER(LEN=SNAME) ::  input_prefix         !< Prefix of input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  flow_prefix          !< Prefix of flow input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  soil_prefix          !< Prefix of soil input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  radiation_prefix     !< Prefix of radiation input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  soilmoisture_prefix  !< Prefix of input files for soil moisture spin-up, e.g. 'laf' for COSMO-DE analyses
     CHARACTER(LEN=SNAME) ::  flow_suffix          !< Suffix of flow input files, e.g. 'flow'
     CHARACTER(LEN=SNAME) ::  soil_suffix          !< Suffix of soil input files, e.g. 'soil'
@@ -249,4 +272,5 @@
     
     SUBROUTINE setup_parameters()
+       INTEGER ::  k
 
 !
@@ -282,6 +306,6 @@
 
        ! Default atmospheric parameters
-       ug = 0.0_dp
-       vg = 0.0_dp
+       cfg % ug = 0.0_dp
+       cfg % vg = 0.0_dp
        cfg % p0 = P_SL
 
@@ -296,4 +320,5 @@
        input_prefix = 'laf'  ! 'laf' for COSMO-DE analyses
        cfg % flow_prefix = input_prefix
+       cfg % input_prefix = input_prefix
        cfg % soil_prefix = input_prefix
        cfg % radiation_prefix = input_prefix
@@ -304,4 +329,7 @@
        radiation_suffix = '-rad'
        soilmoisture_suffix = '-soilmoisture'
+
+       cfg % debug = .FALSE.
+       cfg % averaging_angle = 2.0_dp
 !
 !------------------------------------------------------------------------------
@@ -318,7 +346,17 @@
        cfg % ic_mode = 'volume'
        cfg % bc_mode = 'real'
-
-       ! Update default file names and domain centre
+       cfg % averaging_mode = 'level'
+
+       ! Overwrite defaults with user configuration
        CALL parse_command_line_arguments( cfg )
+
+       flow_prefix = TRIM(cfg % input_prefix)
+       radiation_prefix = TRIM(cfg % input_prefix)
+       soil_prefix = TRIM(cfg % input_prefix)
+       soilmoisture_prefix = TRIM(cfg % input_prefix)
+       IF (cfg % flow_prefix_is_set)  flow_prefix = TRIM(cfg % flow_prefix)
+       IF (cfg % radiation_prefix_is_set)  radiation_prefix = TRIM(cfg % radiation_prefix)
+       IF (cfg % soil_prefix_is_set)  soil_prefix = TRIM(cfg % soil_prefix)
+       IF (cfg % soilmoisture_prefix_is_set)  soilmoisture_prefix = TRIM(cfg % soilmoisture_prefix)
 
        output_file % name = cfg % output_file
@@ -336,4 +374,6 @@
        END IF
 
+
+       ! Set default file paths, if not specified by user.
        CALL normalize_path(cfg % input_path)
        IF (TRIM(cfg % hhl_file) == '')  cfg % hhl_file = TRIM(cfg % input_path) // 'hhl.nc'
@@ -361,12 +401,16 @@
 
        ! Generate input file lists
-       CALL get_input_file_list(cfg % start_date, start_hour_flow, end_hour, step_hour,  &
-          cfg % input_path, cfg % flow_prefix, flow_suffix, flow_files)
-       CALL get_input_file_list(cfg % start_date, start_hour_soil, end_hour, step_hour,  &
-          cfg % input_path, cfg % soil_prefix, soil_suffix, soil_files)
-       CALL get_input_file_list(cfg % start_date, start_hour_radiation, end_hour, step_hour, &
-          cfg % input_path, cfg % radiation_prefix, radiation_suffix, radiation_files)
-       CALL get_input_file_list(cfg % start_date, start_hour_soilmoisture, end_hour_soilmoisture, step_hour, &
-          cfg % input_path, cfg % soilmoisture_prefix, soilmoisture_suffix, soil_moisture_files)
+       CALL get_input_file_list(                                               &
+          cfg % start_date, start_hour_flow, end_hour, step_hour,              &
+          cfg % input_path, flow_prefix, flow_suffix, flow_files)
+       CALL get_input_file_list(                                               &
+          cfg % start_date, start_hour_soil, end_hour, step_hour,              &
+          cfg % input_path, soil_prefix, soil_suffix, soil_files)
+       CALL get_input_file_list(                                               &
+          cfg % start_date, start_hour_radiation, end_hour, step_hour,         &
+          cfg % input_path, radiation_prefix, radiation_suffix, radiation_files)
+       CALL get_input_file_list(                                               &
+          cfg % start_date, start_hour_soilmoisture, end_hour_soilmoisture, step_hour, &
+          cfg % input_path, soilmoisture_prefix, soilmoisture_suffix, soil_moisture_files)
 
 !
@@ -499,4 +543,47 @@
 
  CALL run_control('time', 'comp')
+
+!------------------------------------------------------------------------------
+! Section 4.3: INIFOR averaging domains
+!------------------------------------------------------------------------------
+
+    ! Compute coordiantes of the PALM centre in the source (COSMO) system
+    phi_centre = phirot2phi(                                                   &
+       phirot = project(0.5_dp*ly, y0, EARTH_RADIUS) * TO_DEGREES,             &
+       rlarot = project(0.5_dp*lx, x0, EARTH_RADIUS) * TO_DEGREES,             &
+       polphi = phi_cn * TO_DEGREES, pollam = lambda_cn * TO_DEGREES,          &
+       polgam = gam * TO_DEGREES                                               &
+    ) * TO_RADIANS
+
+    lam_centre = rlarot2rla(                                                   &
+       phirot = project(0.5_dp*ly, y0, EARTH_RADIUS) * TO_DEGREES,             &
+       rlarot = project(0.5_dp*lx, x0, EARTH_RADIUS) * TO_DEGREES,             &
+       polphi = phi_cn * TO_DEGREES, pollam = lambda_cn * TO_DEGREES,          &
+       polgam = gam * TO_DEGREES                                               &
+    ) * TO_RADIANS
+
+    message = "PALM-4U centre:" // NEW_LINE('') // &
+       "           lon (lambda) = " // &
+       TRIM(real_to_str_f(lam_centre * TO_DEGREES)) // " deg" // NEW_LINE(' ') // &
+       "           lat (phi   ) = " // &
+       TRIM(real_to_str_f(phi_centre * TO_DEGREES)) // " deg (COSMO-DE rotated-pole)"
+    CALL report( 'setup_parameters', message )
+
+
+    ! Compute boundaries of the central averaging box
+    averaging_angle = cfg % averaging_angle * TO_RADIANS
+    lam_east = lam_centre + 0.5_dp * averaging_angle
+    lam_west = lam_centre - 0.5_dp * averaging_angle
+    phi_north = phi_centre + 0.5_dp * averaging_angle
+    phi_south = phi_centre - 0.5_dp * averaging_angle
+    averaging_width_ew = averaging_angle * COS(phi_centre) * EARTH_RADIUS
+    averaging_width_ns = averaging_angle * EARTH_RADIUS
+
+    ! Coriolis parameter
+    f3 = 2.0_dp * OMEGA * SIN(                                                 &
+       TO_RADIANS*phirot2phi( phi_centre * TO_DEGREES, lam_centre * TO_DEGREES,&
+                              phi_n * TO_DEGREES, lambda_n * TO_DEGREES,       &
+                              gam * TO_DEGREES )                               &
+       )
 
     END SUBROUTINE setup_parameters
@@ -603,5 +690,5 @@
                ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
                x0=x0, y0=y0, z0 = z0,                                          &
-               nx = nx, ny = ny, nz = nlev - 2)
+               nx = nx, ny = ny, nz = nlev - 1)
 
       IF (boundary_variables_required)  THEN
@@ -824,5 +911,5 @@
                   ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
                   x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 2)
+                  nx = 0, ny = ny, nz = nlev - 1)
 
           CALL init_grid_definition('boundary intermediate', grid=w_west_intermediate,         &
@@ -830,5 +917,5 @@
                   ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
                   x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 2)
+                  nx = 0, ny = ny, nz = nlev - 1)
 
           CALL init_grid_definition('boundary intermediate', grid=w_north_intermediate,        &
@@ -836,5 +923,5 @@
                   ymin = ly + 0.5_dp * dy, ymax = ly + 0.5_dp * dy,               &
                   x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 2)
+                  nx = nx, ny = 0, nz = nlev - 1)
 
           CALL init_grid_definition('boundary intermediate', grid=w_south_intermediate,        &
@@ -842,5 +929,5 @@
                   ymin = -0.5_dp * dy, ymax = -0.5_dp * dy,                       &
                   x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 2)
+                  nx = nx, ny = 0, nz = nlev - 1)
 
           CALL init_grid_definition('boundary intermediate', grid=w_top_intermediate,          &
@@ -848,5 +935,5 @@
                   ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
                   x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = ny, nz = nlev - 2)
+                  nx = nx, ny = ny, nz = nlev - 1)
        END IF
 
@@ -856,32 +943,74 @@
 !------------------------------------------------------------------------------
 
-       profile_grids_required = ( TRIM(cfg % ic_mode) == 'profile' .OR.              &
+       CALL init_averaging_grid(averaged_scalar_profile, cosmo_grid,           &
+               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
+               lonmin = lam_west, lonmax = lam_east,                           &
+               latmin = phi_south, latmax = phi_north,                         &
+               kind='scalar')
+
+       CALL init_averaging_grid(averaged_w_profile, cosmo_grid,                &
+               x = 0.5_dp * lx, y = 0.5_dp * ly, z = zw, z0 = z0,              &
+               lonmin = lam_west, lonmax = lam_east,                           &
+               latmin = phi_south, latmax = phi_north,                         &
+               kind='w')
+
+       CALL init_averaging_grid(south_averaged_scalar_profile, cosmo_grid,     &
+               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
+               lonmin = lam_west, lonmax = lam_east,                           &
+               latmin = phi_centre - averaging_angle,                          &
+               latmax = phi_centre,                                            &
+               kind='scalar')
+
+       CALL init_averaging_grid(north_averaged_scalar_profile, cosmo_grid,     &
+               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
+               lonmin = lam_west, lonmax = lam_east,                           &
+               latmin = phi_centre,                                            &
+               latmax = phi_centre + averaging_angle,                          &
+               kind='scalar')
+
+       CALL init_averaging_grid(west_averaged_scalar_profile, cosmo_grid,      &
+               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
+               lonmin = lam_centre - averaging_angle,                          &
+               lonmax = lam_centre,                                            &
+               latmin = phi_south, latmax = phi_north,                         &
+               kind='scalar')
+
+       CALL init_averaging_grid(east_averaged_scalar_profile, cosmo_grid,      &
+               x = 0.5_dp * lx, y = 0.5_dp * ly, z = z, z0 = z0,               &
+               lonmin = lam_centre,                                            &
+               lonmax = lam_centre + averaging_angle,                          &
+               latmin = phi_south, latmax = phi_north,                         &
+               kind='scalar')
+
+       profile_grids_required = ( TRIM(cfg % ic_mode) == 'profile' .OR.        &
                                   TRIM(cfg % bc_mode) == 'ideal' )
 
-       IF (profile_grids_required)  THEN
-          CALL init_grid_definition('boundary', grid=scalar_profile_grid,      &
-                  xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-                  ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-                  x0=x0, y0=y0, z0 = z0,                                       &
-                  nx = 0, ny = 0, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=w_profile_grid,           &
-                  xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-                  ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-                  x0=x0, y0=y0, z0 = z0,                                       &
-                  nx = 0, ny = 0, nz = nz - 1, z=zw)
-
-          CALL init_grid_definition('boundary', grid=scalar_profile_intermediate,&
-                  xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-                  ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-                  x0=x0, y0=y0, z0 = z0,                                       &
-                  nx = 0, ny = 0, nz = nlev - 2, z=z)
-
-          CALL init_grid_definition('boundary', grid=w_profile_intermediate,   &
-                  xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-                  ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-                  x0=x0, y0=y0, z0 = z0,                                       &
-                  nx = 0, ny = 0, nz = nlev - 2, z=zw)
-       END IF
+       !IF (profile_grids_required)  THEN
+       !   ! Here, I use the 'boundary' kind, so the vertical coordinate uses the
+       !   ! PALM z coordinate.
+       !   CALL init_grid_definition('boundary', grid=scalar_profile_grid,      &
+       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
+       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
+       !           x0=x0, y0=y0, z0 = z0,                                       &
+       !           nx = 0, ny = 0, nz = nz, z=z)
+
+       !   CALL init_grid_definition('boundary', grid=w_profile_grid,           &
+       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
+       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
+       !           x0=x0, y0=y0, z0 = z0,                                       &
+       !           nx = 0, ny = 0, nz = nz - 1, z=zw)
+
+       !   CALL init_grid_definition('boundary', grid=scalar_profile_intermediate,&
+       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
+       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
+       !           x0=x0, y0=y0, z0 = z0,                                       &
+       !           nx = 0, ny = 0, nz = nlev - 2, z=z)
+
+       !   CALL init_grid_definition('boundary', grid=w_profile_intermediate,   &
+       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
+       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
+       !           x0=x0, y0=y0, z0 = z0,                                       &
+       !           nx = 0, ny = 0, nz = nlev - 2, z=zw)
+       !END IF
 
 !                                                                              
@@ -930,6 +1059,5 @@
 
        IF (TRIM(cfg % ic_mode) == 'profile')  THEN
-           CALL setup_averaging(cosmo_grid, palm_intermediate,                 &
-                average_imin, average_imax, average_jmin, average_jmax) 
+           !TODO: remove this conditional if not needed. 
        END IF
         
@@ -938,21 +1066,15 @@
 
 
-    SUBROUTINE setup_interpolation(cosmo_grid, palm_grid, palm_intermediate, kind, ic_mode)
+    SUBROUTINE setup_interpolation(cosmo_grid, grid, intermediate_grid, kind, ic_mode)
 
        TYPE(grid_definition), INTENT(IN), TARGET    ::  cosmo_grid
-       TYPE(grid_definition), INTENT(INOUT), TARGET ::  palm_grid, palm_intermediate
+       TYPE(grid_definition), INTENT(INOUT), TARGET ::  grid, intermediate_grid
        CHARACTER, INTENT(IN)                        ::  kind
        CHARACTER(LEN=*), INTENT(IN), OPTIONAL       ::  ic_mode
 
-       TYPE(grid_definition), POINTER      ::  grid
-       REAL(dp), DIMENSION(:), POINTER     ::  lat, lon
-       REAL(dp), DIMENSION(:,:,:), POINTER ::  h
-
-       LOGICAL :: setup_vertical
-
-       setup_vertical = .TRUE.
-       IF (PRESENT(ic_mode))  THEN
-          IF (TRIM(ic_mode) == 'profile')  setup_vertical = .FALSE.
-       END IF
+       REAL(dp), DIMENSION(:), POINTER     ::  cosmo_lat, cosmo_lon
+       REAL(dp), DIMENSION(:,:,:), POINTER ::  cosmo_h
+
+       LOGICAL :: setup_volumetric
 
 !------------------------------------------------------------------------------
@@ -964,25 +1086,25 @@
        CASE('s') ! scalars
 
-          lat => cosmo_grid % lat
-          lon => cosmo_grid % lon
-          h   => cosmo_grid % hfl
+          cosmo_lat => cosmo_grid % lat
+          cosmo_lon => cosmo_grid % lon
+          cosmo_h   => cosmo_grid % hfl
 
        CASE('w') ! vertical velocity
 
-          lat => cosmo_grid % lat
-          lon => cosmo_grid % lon
-          h   => cosmo_grid % hhl
+          cosmo_lat => cosmo_grid % lat
+          cosmo_lon => cosmo_grid % lon
+          cosmo_h   => cosmo_grid % hhl
 
        CASE('u') ! x velocity
 
-          lat => cosmo_grid % lat
-          lon => cosmo_grid % lonu
-          h   => cosmo_grid % hfl
+          cosmo_lat => cosmo_grid % lat
+          cosmo_lon => cosmo_grid % lonu
+          cosmo_h   => cosmo_grid % hfl
 
        CASE('v') ! y velocity
 
-          lat => cosmo_grid % latv
-          lon => cosmo_grid % lon
-          h   => cosmo_grid % hfl
+          cosmo_lat => cosmo_grid % latv
+          cosmo_lon => cosmo_grid % lon
+          cosmo_h   => cosmo_grid % hfl
 
        CASE DEFAULT
@@ -993,11 +1115,12 @@
        END SELECT
 
-       grid => palm_intermediate
-
-       CALL find_horizontal_neighbours(lat, lon,                               &
-          grid % clat, grid % clon, grid % ii, grid % jj)
-
-       CALL compute_horizontal_interp_weights(lat, lon,                        &
-          grid % clat, grid % clon, grid % ii, grid % jj, grid % w_horiz)
+       CALL find_horizontal_neighbours(cosmo_lat, cosmo_lon,                   &
+          intermediate_grid % clat, intermediate_grid % clon,                  &
+          intermediate_grid % ii, intermediate_grid % jj)
+
+       CALL compute_horizontal_interp_weights(cosmo_lat, cosmo_lon,            &
+          intermediate_grid % clat, intermediate_grid % clon,                  &
+          intermediate_grid % ii, intermediate_grid % jj,                      &
+          intermediate_grid % w_horiz)
 
 !------------------------------------------------------------------------------
@@ -1005,55 +1128,27 @@
 !------------------------------------------------------------------------------
 
-       IF (setup_vertical)  THEN
-          ALLOCATE( grid % h(0:grid % nx, 0:grid % ny, 0:grid % nz) ) 
-          grid % h(:,:,:) = - EARTH_RADIUS
+       ! If profile initialization is chosen, we--somewhat counterintuitively--
+       ! don't need to compute vertical interpolation weights. At least, we
+       ! don't need them on the intermediate grid, which fills the entire PALM
+       ! domain volume. Instead we need vertical weights for the intermediate
+       ! profile grids, which get computed in setup_averaging().
+       setup_volumetric = .TRUE.
+       IF (PRESENT(ic_mode))  THEN
+          IF (TRIM(ic_mode) == 'profile')  setup_volumetric = .FALSE.
+       END IF
+
+       IF (setup_volumetric)  THEN
+          ALLOCATE( intermediate_grid % h(0:intermediate_grid % nx,            &
+                                          0:intermediate_grid % ny,            &
+                                          0:intermediate_grid % nz) ) 
+          intermediate_grid % h(:,:,:) = - EARTH_RADIUS
 
           ! For w points, use hhl, for scalars use hfl
           ! compute the full heights for the intermediate grids
-          CALL interpolate_2d(cosmo_grid % hfl, grid % h, grid)
-          CALL find_vertical_neighbours_and_weights(palm_grid, grid)
+          CALL interpolate_2d(cosmo_h, intermediate_grid % h, intermediate_grid)
+          CALL find_vertical_neighbours_and_weights_interp(grid, intermediate_grid)
        END IF
        
     END SUBROUTINE setup_interpolation
-
-
-    SUBROUTINE setup_averaging(cosmo_grid, palm_intermediate, imin, imax, jmin, jmax)
-
-       TYPE(grid_definition), INTENT(IN) ::  cosmo_grid, palm_intermediate
-       INTEGER, INTENT(INOUT)            ::  imin, imax, jmin, jmax
-
-       TYPE(grid_definition), POINTER    ::  grid
-       REAL(dp)                          ::  lonmin_pos,lonmax_pos, latmin_pos, latmax_pos
-       REAL(dp)                          ::  cosmo_dxi, cosmo_dyi
-
-       cosmo_dxi = 1.0_dp / (cosmo_grid % lon(1) - cosmo_grid % lon(0))
-       cosmo_dyi = 1.0_dp / (cosmo_grid % lat(1) - cosmo_grid % lat(0))
-
-       ! find horizontal index ranges for profile averaging
-       lonmin_pos = (MINVAL(palm_intermediate % clon(:,:)) - cosmo_grid % lon(0)) * cosmo_dxi
-       lonmax_pos = (MAXVAL(palm_intermediate % clon(:,:)) - cosmo_grid % lon(0)) * cosmo_dxi
-       latmin_pos = (MINVAL(palm_intermediate % clat(:,:)) - cosmo_grid % lat(0)) * cosmo_dyi
-       latmax_pos = (MAXVAL(palm_intermediate % clat(:,:)) - cosmo_grid % lat(0)) * cosmo_dyi
-
-       imin = FLOOR(lonmin_pos)
-       imax = CEILING(lonmax_pos)
-       jmin = FLOOR(latmin_pos)
-       jmax = CEILING(latmax_pos)
-       
-       ! average heights for intermediate scalar and w profile grids
-       grid => scalar_profile_intermediate
-       ALLOCATE( grid % h(0:grid % nx, 0:grid % ny, 0:grid % nz) ) 
-       grid % h(:,:,:) = - EARTH_RADIUS
-       CALL average_2d(cosmo_grid % hfl, grid % h(0,0,:), imin, imax, jmin, jmax)
-       CALL find_vertical_neighbours_and_weights(scalar_profile_grid, grid)
-
-       grid => w_profile_intermediate
-       ALLOCATE( grid % h(0:grid % nx, 0:grid % ny, 0:grid % nz) ) 
-       grid % h(:,:,:) = - EARTH_RADIUS
-       CALL average_2d(cosmo_grid % hhl, grid % h(0,0,:), imin, imax, jmin, jmax)
-       CALL find_vertical_neighbours_and_weights(w_profile_grid, grid)
-
-    END SUBROUTINE setup_averaging
-
 
 !------------------------------------------------------------------------------!
